unit StatDLL;

interface

type
  TStatResult = (srOK, srInvalidContext, srNoData, srNoMemory, srMaxSamples,
    srInvalidSample, srError, crNoStandard);
  TCalcResult = (crMean, crSum, crSumOfSquares, crStandard, crPopulation);

  TStatContext = Pointer;

  PSample = ^TSample;
  TSample = record
    Sample: Real;
  end;

  TGetMem = procedure(var P: Pointer; Size: Word);
  TFreeMem = procedure(var P: Pointer; Size: Word);

function InitCalc(Size, Delta: Integer; GetMem: TGetmem; FreeMem: TFreeMem):
  TStatContext;
function AddSample(Context: TStatContext; const Sample: TSample):
  TStatResult;
function DeleteSample(Context: TStatContext; Item: Integer):
  TStatResult;
procedure DoneCalc(Context: TStatContext);
function GetSample(Context: TStatContext; Item: Integer;
  var Sample: PSample): TStatResult;
function SampleCount(Context: TStatContext; var ACount: Integer): TStatResult;
function GetCalc(Context: TStatContext; Calc: TCalcResult;
  var Result): TStatResult;

implementation

function InitCalc; external 'STAT';
function AddSample; external 'STAT';
function DeleteSample; external 'STAT';
procedure DoneCalc; external 'STAT';
function GetSample; external 'STAT';
function SampleCount; external 'STAT';
function GetCalc; external 'STAT';

end.

