
; ===========================================================================
;  
        .386p

;*****************************  INCLUDES  **********************************

.xlist
        include vmm.inc     
	include debug.inc

	Create_SCS_Service_Table equ 1
	include SCS.inc

.list


;********************  VIRTUAL DEVICE DECLARATION  *************************

Declare_Virtual_Device SCS, 3, 1, SCS_Control, SCS_Device_ID,  \
                      Undefined_Init_Order,, SCS_PROTAPI_Proc



MAXPATH equ 64

VxD_LOCKED_DATA_SEG
VxD_LOCKED_DATA_ENDS




VxD_DATA_SEG
	jumptable	dd   offset32 GetVersion
			dd   offset32 Init
			dd   offset32 ShutDown
			dd   offset32 Resume
	VxDAddress	dd   0
	Shell		dd   0

	VMClient	dd   0

	ProgNameSel	dd   0
	CommandLineSel	dd   0
	failed		dd   0
	fClose		dd   0
        SemHand		dd   0
	ShellName	db	"COMMAND.COM"
			db	0

VxD_DATA_ENDS

;**********************  INITIALIZATION DATA SEG  **************************

VxD_IDATA_SEG


VxD_IDATA_ENDS


;***************  INITIALIZATION CODE SEG: PROTECT MODE  *******************

VxD_ICODE_SEG



;** SCS_Device_Init

BeginProc SCS_Device_Init


        
	    VMMCall _BuildDescriptorDWORDS,<0,0,0f2h,0,0>

            push    eax
            push    edx

            VMMCall _Allocate_GDT_Selector,<edx,eax,0>
            mov     ProgNameSel,eax
            pop     edx
            pop     eax

	    VMMCall _BuildDescriptorDWORDS,<0,0,0f2h,0,0>
	    push    eax
            push    edx

	    VMMCall _Allocate_GDT_Selector,<edx,eax,0>
            mov     CommandLineSel,eax
	    pop     edx
            pop     eax




;
;    Create_Semaphore
;

            mov     ecx,1
            VMMCall Create_Semaphore
            mov     SemHand,eax
            jc      short ErrorDI


NoAutoStart:
            mov     eax,21h
            mov     esi,offset32 Int21Handler
            VMMCall Hook_V86_Int_Chain
            mov     VxDAddress,0
            clc                                     ; no error

ErrorDI:
            ret


EndProc SCS_Device_Init


VxD_ICODE_ENDS



;**************************  LOCKED CODE SEG  ******************************


VxD_LOCKED_CODE_SEG

BeginProc SCS_Control
        Control_Dispatch Device_Init, SCS_Device_Init
        clc
        ret
EndProc   SCS_Control

VxD_LOCKED_CODE_ENDS



;*************************  PROTECT MODE CODE SEG  *************************


VxD_CODE_SEG

;
; return Windows 3.1 compatibility because of the use of 3.1 only semaphores
;


BeginProc SCS_Get_Version, SERVICE
        mov   eax,31h
        clc
        ret
EndProc   SCS_Get_Version


;
;   Protected Mode API entry point
;

;
; eax contains function
; ebx parameter 1 DWORD
; ecx parameter 2 DWORD
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; GetVersion, Init, Shutdown, Resume all correspond to 
;; the VxdApicall in scswin.cpp
;; SCSWIN makes these calls to suspend and resume
;; as well as turn on and off the SCS driver
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



BeginProc SCS_PROTAPI_Proc
	movzx	eax,[ebp.Client_ax]
	cmp	eax,MAX_API
	jae	short Bad_Api_Error
	jmp	[eax*4+jumptable]

GetVersion:
	mov	[ebp.Client_eax],031h
Bad_Api_Error:
	ret


Shutdown:
     
	mov	VxDAddress,0
	ret



Init:

	mov	edx,DWORD PTR [ebp.Client_ebx] ; Address for VxD to call
	mov	VxDAddress,edx
	ret

Resume:
	cmp	ecx,TRUE
	je	short avail
	mov	failed,1
	jmp	short avail2
	
avail:	mov	failed,0
avail2:	mov	ebx, VMClient
	VMMCall	No_Fail_Resume_VM

	mov	eax,SemHand
	VMMCall	Signal_Semaphore


	ret

EndProc   SCS_PROTAPI_Proc



BeginProc Int21Handler
	pushad 
	Push_Client_State                  ;
	cmp	VxDAddress,0               ; If the SCSWIN is not
	je	noexec                      ; running, We don't
	       				   ; need to check	
	
	cmp	[ebp.Client_AX],4b00h
	jne	noexec
	mov	VMClient, ebx
	mov	ecx,Block_Svc_Ints		; Block on Critical section
	VMMCall	Begin_Critical_Section		; to make sure no other VM's
	VMMCall	End_Critical_Section		; Own it
	VMMCall	Get_Crit_Section_Status		; If !=0 then this VM owns
	or	ecx,ecx				; the critical section
	jc	DosVMinCrit			; Can't continue

;
;   At this point we know that the critical section is unowned.
;   This prevents the possiblity of a deadlock if the event code claims
;   the critical section. This should not be a problem as long as the DOS
;   VM is calling this interrupt from Application code.
;


	Client_Ptr_Flat esi, DS, DX     ;turn ds:dx into a flat ptr
					;Windows programs cannot read
                                        ;real mode addresses so we
                                        ;convert them to flat pointers
                                        ; later on we convert the
                                        ; flat ptrs to selector:offsets
	mov	edi,0
	push	esi
	mov	ecx,MAXPATH	       ;don't bother checking command.com
	repnz	cmpsb		       ;it can cause a deadlock
	mov	eax,MAXPATH	       ;
	sub	eax,ecx		       ;
	cmp	eax,13		       ;
	jl	short NotShell	       ;
	sub	esi,13		       ;
	mov	edi,offset32 ShellName ;
	mov	ecx,11		       ;
	repz	cmpsb		       ;
	jz	short IsShell	       ;
	jmp	short NotShell	       ;
IsShell:

	mov	Shell, TRUE




NotShell:
	pop	esi
	cmp	Shell,TRUE
	je	EventDone


;
;    ESI now points to the file name pointed to by Client DS:DX
;



;
;    Now build the decriptor pointed to by ESI to point to the
;    file name. This turns the flat pointer into a selector:offset
;

	VMMCall	_BuildDescriptorDWORDS,<esi,0ffffh,0f2h,0,0>
	VMMCall	_SetDescriptor,<ProgNameSel,0,edx,eax,0>
	Push_Client_State
	Client_Ptr_Flat esi, ES, BX     ;turn client es:bx into a flat ptr

;
;
; Retrieve the Command Tail
;
;

 	add	esi,2
 	mov     ax, WORD PTR [esi]
 	mov     [ebp.Client_BX], ax
 	mov     ax, WORD PTR [esi+2]
	mov     [ebp.Client_ES], ax


	Client_Ptr_Flat esi, ES, BX     ;turn client es:bx into a flat ptr
;	push	esi
;	mov	eax,0
;	mov	al,BYTE PTR [esi]  ; first byte is length byte
;	mov	[esi],BYTE PTR 20h ; replace it with a
;	add	esi,eax
;	inc	esi
;	mov	[esi],BYTE PTR 0
;	pop	esi
	VMMCall	_BuildDescriptorDWORDS,<esi,0ffffh,0f2h,0,0>
	VMMCall	_SetDescriptor,<CommandLineSel,0,edx,eax,0>
   	

 	Pop_Client_State
		
;
;    Schedule a VM event for the SYS VM
;

	VMMCall	Begin_Critical_Section
	VMMCall	Get_Sys_VM_Handle
	mov	eax,Time_Critical_Boost
	mov	ecx,PEF_Wait_For_STI + PEF_Always_Sched
	xor	edx,edx
	mov	esi,offset32 SysVMEvent
	VMMCall	Call_Priority_VM_Event
	VMMCall	End_Crit_And_Suspend


	mov	eax,SemHand
	mov	ecx,Block_Svc_Ints
	VMMCall	Wait_Semaphore

EventDone:
DosVMinCrit:
	mov	Shell,FALSE
	Pop_Client_State
	popad
	cmp	failed,1
	je	short Dontpass
	stc                      ; chain to next handler
	ret
Dontpass:
	clc                      ; This will cause the dos app to fail
	ret                      ; and will place the user back at the         
                                 ; command line.      
noexec:


	Pop_Client_State
	popad
	stc
	ret

EndProc	Int21Handler


;
;    This is the SYS VM event code
;    It Simulates a FAR call into the SysVM
;    The Call that it is simulating is prototyped as
;
; WORD FAR PASCAL _export 
; VxDCallbackFunc(DWORD dwCmdLine);

;
;    When the call returns this event code clears the semaphore
;
;
;
;


BeginProc	SysVMEvent

	mov	ecx,Block_Svc_Ints
	VMMCall	Begin_Critical_Section

	Push_Client_State                       
	VMMCall	Begin_Nest_Exec

;
; For 16-bit far calls, only the loword of eax is used.
; Since bothe ProgNameSel and CommandSel are being pushed
; the VxdCallbackFunc will have to crack the arguments.
;

	mov	eax,ProgNameSel
	VMMCall	Simulate_Push

	mov	eax, CommandLineSel
	VMMCall	Simulate_Push

	mov	cx,WORD PTR VxDAddress+2       ; simulate the call
	movzx	edx,WORD PTR VxDAddress        ; The protected mode
                                               ; address contains
 					       ; VxdAPICall	
	VMMCall	Simulate_Far_Call

	VMMCall	Resume_Exec		       ; This VM (the DOS Box)
					       ; will be frozen until
                                               ; Resume_Exec is called
	VMMCall	End_Nest_Exec
	Pop_Client_State

	VMMCall  End_Critical_Section
	ret

EndProc	SysVMEvent

VxD_CODE_ENDS


VxD_REAL_INIT_SEG  

VxD_REAL_INIT_ENDS

	end 
