// scswin.cpp : 
//
// SCSWIN "turns" SCS.386 ON or OFF and also determines if an executable
// is a Windows, Win32s or DOS application
//
//
//
#include "stdafx.h"

#include "resource.h"
#include "scswin.h"

/////////////////////////////////////////////////////////////////////////////

// theApp:
// Just creating this application object runs the whole application.
//
CTheApp NEAR theApp; 
FARPROC lpfnSCSWIN;


/////////////////////////////////////////////////////////////////////////////

// CMainWindow constructor:
// Create the window with the appropriate style, size, menu, etc.
//
CMainWindow::CMainWindow()
{
	Create( NULL, "Single Command Shell",
		WS_OVERLAPPEDWINDOW, rectDefault, NULL, "MainMenu" );

}

//
// OnAbout:
// We create a ClDialog object using the "AboutBox" resource (see
// scswin.rc), and invoke it.
//

void CMainWindow::OnAbout()
{
    CDialog about( "AboutBox", this );
	about.DoModal();
}
  
  
// CMainWindow message map:
// Associate messages with member functions.
//
// It is implied that the ON_WM_PAINT macro expects a member function
// "void OnPaint()".
//
// It is implied that members connected with the ON_COMMAND macro
// receive no arguments and are void of return type, e.g., "void OnAbout()".
//
BEGIN_MESSAGE_MAP( CMainWindow, CFrameWnd )
	//{{AFX_MSG_MAP( CMainWindow )
	ON_MESSAGE(WM_USER, OnExec)
        ON_WM_QUERYOPEN()
	ON_WM_ENDSESSION() 
	ON_WM_SYSCOMMAND() 
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//
//   VxDApiCall communicates with SCS.386, Since SCS.386 expects 
//   its parameters in the ebx and ecx registers it is necessary to
//   use the _asm and _emit keywords.
//
//

extern "C" {DWORD __VxDApiCall;}
#pragma optimize("qgel", off) // assembler cannot be globally optimized

void FAR PASCAL
CTheApp::VxDApiCall(SCS_API Function, DWORD /*param1*/, DWORD /*param2*/)
{

   if (__VxDApiCall)
	 _asm
	{
	mov	ax,Function

//;
//; mov     ebx,param1
//;
      _emit  0x66  ;
      _emit  0x8B  ;
      _emit  0x5E   
      _emit  0x0C   

//;
//; mov     ecx,param2
//;
      _emit 0x66
      _emit 0x8B
      _emit 0x4E
      _emit 0x08

       call	DWORD PTR __VxDApiCall
       }


} 

//
// Call the INT 2F AX=1684 function to determine if SCS.386 is
// installed. If so retrieve the address for the API calls 
//
//

BOOL 
CTheApp::GetVxDApiCallAddress(UINT VxDID)
{

BOOL rtn = FALSE;
_asm {
	mov  bx,VxDID
	mov  ax,1684h
	int  2fH
	mov  dx,es
	or   dx,dx
	jz error
	mov  WORD PTR __VxDApiCall,di
	mov  WORD PTR __VxDApiCall+2,es
	mov	rtn,TRUE;
   	error:

	
     }

return rtn;

}

#pragma optimize("", on)    // return to default optimizations

// InitInstance:
// Make sure only one instance executes.
// Make sure that 386 enhanced mode is running
// Determine if SCS.386 is loaded
// Create the Window

BOOL CTheApp::InitInstance()
{
       if (m_hPrevInstance)
          return FALSE;
       if ((GetWinFlags() & WF_ENHANCED) == WF_ENHANCED)
       {
       if (GetVxDApiCallAddress(VXDID))
          {
          lpfnSCSWIN = MakeProcInstance((FARPROC)VxDCallbackFunc,
		                    AfxGetInstanceHandle());
          VxDApiCall(SCS_INIT,(LONG)lpfnSCSWIN,0l);
          }
       else 
          {
          MessageBox(NULL,"You need to install SCS.386",
                          "Error",MB_OK|MB_ICONSTOP);   
          return FALSE;
          }
        }  
	m_pMainWnd = new CMainWindow();
        m_pMainWnd->GetSystemMenu(FALSE)->AppendMenu(MF_SEPARATOR);

        m_pMainWnd->GetSystemMenu(FALSE)->AppendMenu(MF_STRING | 
                                MF_ENABLED, 
                                IDM_ABOUT, "About...");
 	m_pMainWnd->ShowWindow(SW_SHOWMINIMIZED);
      
	return TRUE;
}

//
// ExitInstance:
// Turn off SCS.386 
//
BOOL CTheApp::ExitInstance()
{
 VxDApiCall(SCS_SHUTDOWN,0l,0l);
 return CWinApp::ExitInstance();	
}
  
  
CMainWindow::OnQueryOpen()
{
OnAbout();
return FALSE;
  
}
void 
CMainWindow::OnEndSession(BOOL bEnding)
{
   if (bEnding)
      theApp.VxDApiCall(SCS_SHUTDOWN,0,0);
} 



void CMainWindow::OnSysCommand(UINT nID, LONG /*lParam*/)
{
    switch (nID)
    {
    case IDM_ABOUT:
         OnAbout();
         break;
    default:
         Default();
    };
}    

//
// OnExec:
// The lion's share of the work takes place here.
// Determine if this is a DOS, Windows or Win32s application
// The WinExec or give control back to SCS.386 as appropriate
//
//
   
  
LONG
CMainWindow::OnExec(UINT wParam, LONG lParam)
{
CString s;
HFILE hFile ;
OFSTRUCT ofFile ;
WORD wTemp ;
WORD DosSignature;  
WORD NESignature;
DWORD NTSignature; 
WORD Subsystem;
char cbLen;


//
// Unpack executable's name and command tail 
// from lParam
//

LPSTR lpszProgName = (LPSTR) MAKELP(HIWORD(lParam),0);
LPSTR lpszCmdTail = (LPSTR) MAKELP(LOWORD(lParam),0);

 

//
// If the pointers are bad let DOS handle it
//

  if (IsBadWritePtr(lpszProgName,1))
     {
     TRACE("lpszProgName is bad");
     theApp.VxDApiCall(SCS_RESUME,1l,-1l); 
     return 0l;
     } 
     
  if (IsBadWritePtr(lpszCmdTail,1))
     {
     TRACE("lpszProgName is bad");
     theApp.VxDApiCall(SCS_RESUME,1l,-1l); 
     return 0l;
     } 
     

  hFile = OpenFile( lpszProgName, &ofFile, OF_READ );
  ASSERT (hFile != NULL);
//
// If this is not a valid executable let DOS handle it
// 
   _lread( hFile, &DosSignature, 2 ) ;
   if (DosSignature != IMAGE_DOS_SIGNATURE)
      {
      _lclose ( hFile );
      theApp.VxDApiCall(SCS_RESUME,1l,-1l);
      return 0;
      }

// 
// Determine if this is a Win32s EXE
//

   _llseek(hFile, 0L, 0);
   _llseek(hFile, (LONG) IMAGE_SECOND_HEADER_OFFSET, SEEK_SET);
   _lread(hFile,  &NTSignature, 4);
   _llseek(hFile, 0L, 0);
   _llseek(hFile, (LONG) NTSignature, SEEK_SET);
   _lread(hFile,  &NTSignature, 4);

   if (NTSignature == IMAGE_NT_SIGNATURE)
      {
      
//
// See if it is a character based Win32s application.
// See if it is character based (CUI) If so send it back
// to DOS
//        
  
      _llseek(hFile, 0x58, 1); //seek to subsystem
      _lread(hFile, &Subsystem, 2);
      if (Subsystem == IMAGE_SUBSYSTEM_WINDOWS_CUI)
         {    
         _lclose ( hFile );
         theApp.VxDApiCall(SCS_RESUME,1l,-1l);
         ::SetFocus((HWND)wParam);
         return 0l;
         }
      if (Subsystem == IMAGE_SUBSYSTEM_WINDOWS_GUI)
         {    
         cbLen = *lpszCmdTail; 
         *lpszCmdTail = ' ';  
         *(lpszCmdTail+cbLen+1) = ' '; 
         s = lpszProgName;
         s += ' '; 
         s += lpszCmdTail;
         _lclose (hFile);
         if ((WinExec (s,SW_SHOWNORMAL)) < 32)  //Windows EXE 
           { 
           theApp.VxDApiCall(SCS_RESUME,1l,-1l);  // let DOS handle it
           return 0l;
           }
         else
           {
           theApp.VxDApiCall(SCS_RESUME,0l,0l);   
           return 0l;
           }
 
     	 }
      }
//
// Determine if this is a Windows EXE (Win32s - Windows GUI will pass this test)
//
   _llseek( hFile, 0L, 0 );
   _llseek( hFile, (LONG) IMAGE_HEADER_FTYPE, SEEK_SET ) ;
   _lread( hFile, &wTemp, 2 ) ;

   if (wTemp == IMAGE_HEADER_WINDOWS)
      { 
      _llseek( hFile, 0L, 0 );
      _llseek( hFile, (LONG) IMAGE_SECOND_HEADER_OFFSET, SEEK_SET );     
      
      _lread( hFile,  &NESignature, 2 ); 
      
      _llseek( hFile, 0L, 0 );
      _llseek( hFile, (LONG) NESignature, SEEK_SET );
        
      _lread( hFile,  &NESignature, 2 );
      _lclose ( hFile );
      if (NESignature == IMAGE_NE_SIGNATURE)       
         {
        
//
// If SCS barfs on any particular file, you can turn it off via a 
// switch in SCS.INI
//                       
 
         static char path_buffer[_MAX_PATH];
         static char fname[_MAX_FNAME];
         lstrcpy(path_buffer,lpszProgName);
         _splitpath( path_buffer, NULL, NULL, fname, NULL );
         if (GetPrivateProfileInt("DosApp",fname, 0, "SCS.INI")) 
            {
           //MessageBox(NULL,fname,"DOS APP",MB_OK|MB_SYSMODAL);
            theApp.VxDApiCall(SCS_RESUME,1l,-1l);  // let DOS handle it
            return 0l;
            }      
      
//
// command tails contain a leading length byte and a
// trailing carriage return that WinExec doesn't need
// the following three lines remove them.
//       
         cbLen = *lpszCmdTail; 
	     *lpszCmdTail = ' ';  
         *(lpszCmdTail+cbLen+1) = ' '; 
         s = lpszProgName;
         s += ' '; 
         s += lpszCmdTail;
         if ((WinExec (s,SW_SHOWNORMAL)) < 32)  //Windows EXE 
            {    
            *lpszCmdTail = cbLen; 
            *(lpszCmdTail+cbLen+1) =  '\r';
            theApp.VxDApiCall(SCS_RESUME,1l,-1l);  // let DOS handle it
            return 0l;
            }
         else
            {
            theApp.VxDApiCall(SCS_RESUME,0l,0l);   
            return 0l;
            }
         }
      theApp.VxDApiCall(SCS_RESUME,1l,-1l);  // 
      return 0l; 
      }
   else   
      {
        _lclose ( hFile );
       theApp.VxDApiCall(SCS_RESUME,1l,-1l);
       ::SetFocus((HWND)wParam);
       }
   return 0l;     

}

//////////////////////////////////////////////////////////////////////////
//  This function is called by the SCS VxD. It contains pointers
//  to the program name and  the command line of file that was 
//  requested  to run.
//////////////////////////////////////////////////////////////////////////

WORD FAR PASCAL _export 
VxDCallbackFunc(DWORD dwCmdLine)
{
  PostMessage(AfxGetApp()->m_pMainWnd->GetSafeHwnd(),
              WM_USER,(UINT)GetFocus(),(LONG)dwCmdLine);
  return 0;
}

      

