// RSFILEAR.H

#ifndef __RSFILEAR_H
#define __RSFILEAR_H

#include "rsfiles.h"

#ifdef RS_BUILD_MAC
typedef void *LPVOID;
#endif

template <class ElementType>
class RS_TFileArray
{
public:
  enum { kFileArrayError = -1 };
  RS_TFileArray(RS_CFile &theFile, long size = -1);
  RS_TFileArray();
  virtual ~RS_TFileArray();
  int IsInitialized();
  ElementType& operator[](int);
private:
  int AllocateBuffer(long size);
  void FreeBuffer();
#if defined(RS_BUILD_WIN16) || defined(RS_BUILD_MAC) 
  int LoadBuffer(); 
  void FlushBuffer();
#endif
  RS_CFile *fFile;
  int fInitialized;
  long fBufferSize;
  LPVOID fMemoryPointer;
#ifdef RS_BUILD_WIN32
  HANDLE fHandle;
#endif
};

template <class ElementType>
inline int RS_TFileArray<ElementType>::IsInitialized()
{
  return fInitialized;
}

template <class ElementType>
inline ElementType& RS_TFileArray<ElementType>::operator[](int index)
{
  return ((ElementType *)fMemoryPointer)[index];
}
#endif // __RSFILEAR_H


